<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :ok-text="isNew ? 'Добавить' : 'Сохранить'"
    :is-read-only="isReadOnly"
    :is-active-element="isActiveUser"
    :dropdown-menu="dropdownMenu"
    @submit="onSaveForm"
    @change-active="setActive"
    class="users-user-form"
  >
    <ob-tabs
      ref="tabs"
    >
      <ob-tabs-pane title="Основная информация" :is-selected="true">
        <div class="row">
          <div class="col-xs-4">
            <ob-input
              label="Фамилия"
              v-model="formData.last_name"
              :required="true"
              placeholder="Введите фамилию"
              property="last_name"
            />
          </div>
          <div class="col-xs-4">
            <ob-input
              label="Имя"
              v-model="formData.first_name"
              :required="true"
              placeholder="Введите имя"
              property="first_name"
            />
          </div>
          <div class="col-xs-4">
            <ob-input
              label="Отчество"
              v-model="formData.patronymic"
              placeholder="Введите отчество"
              property="patronymic"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-12">
            <ObCheckbox
                label="Свободный формат номера телефона"
                v-model="isFreePhoneFormat"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-6">
            <ob-input
              label="Телефон"
              v-model="formData.phone"
              :placeholder="isFreePhoneFormat ? 'Укажите номер телефона' : '+7 (999) 999-99-99'"
              :mask="isFreePhoneFormat ? '' : '+7 (999) 999-99-99'"
              :required="true"
              property="phone"
            />
          </div>
          <div class="col-xs-6">
            <ob-input
              label="Email"
              v-model="formData.email"
              placeholder="Введите email"
              property="email"
              :readonly="!isNew"
              :is-valid="isEmailExist"
              :required="true"
              :validation-message="errors.emailExist ? 'Пользователь с таким email уже существует в системе' : ''"
              @input="onInputEmail"
            />
          </div>
        </div>
        <div class="row">
          <div class="col-xs-12">
            <ob-select
              label="Роль пользователя"
              v-model="formData.worker_roles"
              :remote-opt="getRoles"
              placeholder="Добавьте хотя бы одну роль"
              display-exp="title"
              :is-dropdown="true"
              :is-multiselect="true"
              :required="true"
              property="worker_roles"
            />
          </div>
        </div>
      </ob-tabs-pane>

      <ob-tabs-pane
        title="Организации"
        :is-disabled="isOrganizationsDisabled"
      >
        <div class="user-orgs">
          <div class="row">
            <div class="col-xs-12">
              <ob-input
                label="Название участника"
                v-model="formData.contractor_title"
                property="contractor_title"
              />
            </div>
          </div>
          <div class="row">
            <div class="col-xs-12">
              <ob-select
                label="Организации, за которые напрямую отвечает сотрудник"
                v-model="formData.organizations"
                placeholder="Добавьте организации"
                :initial-value="initialOrganizationList"
                :is-dropdown="true"
                :is-multiselect="true"
                :is-auto-complete="true"
                :remote-opt="{ method: getOrganizations }"
              />
            </div>
          </div>
        </div>
      </ob-tabs-pane>
    </ob-tabs>
  </ob-form>
</template>

<script>
  import api from '@/api'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import ObForm from "common-components/src/obComponents/obForm"
  import ObInput from "common-components/src/obComponents/obInput"
  import ObSelect from "common-components/src/obComponents/obSelect"
  import ObTabs from "common-components/src/obComponents/obTabs"
  import ObTabsPane from "common-components/src/obComponents/obTabs/ObTabsPane"
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import { required, email } from 'vuelidate/lib/validators'
  import { uuid } from 'vue-uuid'

  import { mapGetters } from 'vuex'

  const initErrors = {
    emailExist: false
  }

  export default {
    name: 'UsersUserModal',
    components: {
      ObForm,
      ObInput,
      ObSelect,
      ObTabs,
      ObTabsPane,
      ObCheckbox
    },
    mixins: [
      FormValidationMixin
    ],
    data() {
      return {
        errors: {
          ...initErrors
        },
        isFreePhoneFormat: false,
        initialOrganizationList: []
      }
    },
    watch: {
      'dataSource.uuid' (value) {
        if (!value) {
          this.$refs.tabs && this.$refs.tabs.setInitSelected()
        }
      },
      'parentModal.visible' () {
        this.clearError()
      }
    },
    computed: {
      ...mapGetters({
        isClicar: 'user/isClicar',
        isLocalAdmin: 'user/isLocalAdmin',
        userUuid: 'user/userUuid',
        participantUuid: 'user/participantUuid'
      }),
      isNew () {
        return !this.dataSource.uuid
      },
      isOrganizationsDisabled () {
        return !this.isClicar || this.isNew
      },
      isReadOnly () {
        return !this.isLocalAdmin
      },
      isActiveUser () {
        if (!this.dataSource.uuid || this.isSelfUser) {
          return null
        }

        return this.formData.is_active
      },
      isSelfUser () {
        return this.userUuid === this.dataSource.uuid
      },
      dropdownMenu () {
        return [
          {
            title: 'Удалить',
            icon: 'delete icon-delete-red',
            className: 'menu-button-danger',
            isHidden: this.isNew || this.isSelfUser,
            method: this.deleteUser
          }
        ]
      },
      formModel () {
        return {
          uuid: {
            value: ''
          },
          last_name: {
            value: '',
            validator: {
              required
            }
          },
          first_name: {
            value: '',
            validator: {
              required
            }
          },
          patronymic: {
            value: ''
          },
          phone: {
            value: '',
            validator: {
              required,
              minLength: {
                method: this.checkMinLength,
                error: 'Некорректный номер телефона'
              }
            }
          },
          worker_roles: {
            type: 'array',
            value: [],
            validator: {
              required
            }
          },
          is_active: {
            value: false
          },
          email: {
            value: '',
            validator: {
              required,
              email: {
                method: email,
                error: 'Введет некорректный email'
              }
            }
          },
          organizations: {
            value: []
          },
          contractor_title: {
            value: ''
          }
        }
      },
      isEmailExist () {
        if (!this.errors.emailExist) return null

        return false
      }
    },
    methods: {
      async getRoles () {
        return await api.user_roles.getUserRoles()
      },
      async getOrganizations () {
        if (this.isOrganizationsDisabled) {
          return [] // Prevent calling 'getUserOrgs' with nonexistent params
        }

        const response = await api.adminPanel.users.getUserOrgs(this.dataSource.uuid, ...arguments)

        response.values = response.responseOrganizationList.organizationDropDownList
        this.initialOrganizationList = response.responseOrganizationList.organizationUserList

        return response
      },
      setActive (value) {
        this.formData.is_active = value
      },
      async onSaveForm (data) {
        this.clearError()
        await this.isNew ? this.addUser(data) : this.updateUser(data)
      },
      async addUser (data) {
        try {
          data.uuid = uuid.v4()
          data.contractorUuid = this.participantUuid
          await api.adminPanel.users.createUser(data)
          await api.adminPanel.users.updateUserRoles(data, true)
          this.$emit('submitted')
        } catch ({ error }) {
          if (error === 'EMAIL_ALREADY_EXISTS') {
            this.errors.emailExist = true
          }
        }
      },
      async updateUser (data) {
        let notificationId = new Date().getTime() + 'save'
        let message = 'Не удалось обновить данные пользователя'
        try {
          this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId})
          await api.adminPanel.users.updateUser(data)
          data.contractor_uuid = this.participantUuid
          if (this.dataSource && this.dataSource.is_active !== data.is_active) {
            await api.adminPanel.users.updateUserStatus(data)
          }
          if (data.organizations && data.organizations.length) {
            await this.onSaveOrgs(data.organizations)
          }
          if (data.worker_roles && this.dataSource.worker_roles && JSON.stringify(data.worker_roles) !== JSON.stringify(this.dataSource.worker_roles)) {
            await api.adminPanel.users.updateUserRoles(data)
          }
          this.$notification({type: 'system_notification_success', message: 'Сохранено'})
          this.$emit('submitted')
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message
          })
        } finally {
          this.$notification({event: 'close', id: notificationId})
        }
      },
      async onSaveOrgs (data) {
        const payload = {
          organizations: [...data]
        }
        let notificationId = new Date().getTime() + 'save'
        try {
          this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId})
          await api.adminPanel.users.updateUserOrgs(this.dataSource.uuid, payload)
          this.$notification({type: 'system_notification_success', message: 'Сохранено'})
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Не сохранено'
          })
        } finally {
          this.$notification({event: 'close', id: notificationId})
        }
      },
      async deleteUser () {
        let notificationId = new Date().getTime() + 'save'
        try {
          this.$notification({type: 'system_notification_in_load', message: 'Удаление', id: notificationId})
          await api.adminPanel.users.deleteUser({ uuid: this.dataSource.uuid })
          this.$notification({type: 'system_notification_success', message: 'Удален'})
          this.$emit('submitted')
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка удаления'
          })
        } finally {
          this.$notification({event: 'close', id: notificationId})
        }
      },
      clearError () {
        this.errors = {
          ...initErrors
        }
      },
      onInputEmail () {
        if (this.errors.emailExist) {
          this.errors.emailExist = false
        }
      },
      checkMinLength (value) {
        if (this.isFreePhoneFormat) {
          return true
        }

        return value ? value.length >= 10 : false
      }
    }
  }
</script>
<style lang="scss" scoped>
  .users-user-form {
    &::v-deep {
      .menu-button-danger {
        button {
          color: $color-error;
        }
      }
    }
  }
</style>
